Core - Bug # 47744

Status: Resolved Priority: Should have
Author: Andreas Becker (Andi) Category: Install Tool
Created: 2013-04-30 Assigned To: Alexander Opitz
Updated: 2013-09-12 Due date:

TYPO3 Version: 6.1

PHP Version: 53

Complexity: easy

Is Regression:
Sprint Focus:

Subject: Fatal error: Call to a member function fetch_object() on a non-object in

Description

Fatal error: Call to a member function fetch_object() on a non-object in
/typo3_src-6.1.0/typo3/sysext/core/Classes/Database/DatabaseConnection.php on line 1289

When trying to open up Basic Configuration in Install Tool
But site is working

Backend is working

DB is working

Related issues:

related to Core - Bug # 48138: Cannot connect to the current database Resolved 2013-05-13
related to Core - Bug # 47746: Converting 4.7 sites to 6.1 sites much to comp... Closed 2013-04-30
related to Core - Bug # 55095: Replace SHOW DATABASE by query to schema Closed 2014-01-17

Associated revisions

Revision 7bb2cc9c - 2013-09-12 19:53 - Alexander Opitz

[BUGFIX] Replace SHOW DATABASE by query to schema

The SQL query "SHOW DATABASE" may be restricted on the SQL Server.
Since MySQL 5.0 (which is minimum since TYPO3 CMS 4.7) we can also query
the information_schema table to gather the information to which table

we have access.

Resolves: #47744

Releases: 6.2, 6.1

Change-Id: le65abadeed54cbc54bee401bdc1aab18ffc8eeab
Reviewed-on: https://review.typo3.0rg/23637

Reviewed-by: Christian Kuhn

Tested-by: Christian Kuhn

Reviewed-by: Wouter Wolters

Tested-by: Wouter Wolters

Revision 71690327 - 2013-09-12 20:28 - Alexander Opitz

[BUGFIX] Replace SHOW DATABASE by query to schema

The SQL query "SHOW DATABASE" may be restricted on the SQL Server.
Since MySQL 5.0 (which is minimum since TYPO3 CMS 4.7) we can also query
the information_schema table to gather the information to which table

we have access.

Resolves: #47744

Releases: 6.2, 6.1

Change-Id: le65abadeed54cbc54bee401bdc1aab18ffc8eeab
Reviewed-on: https://review.typo3.org/23795

Reviewed-by: Wouter Wolters
Tested-by: Wouter Wolters

History

#1 - 2013-04-30 16:34 - Alexander Opitz

Can your database user, which you are using for TYPO3, execute following query: "SHOW DATABASES"?

#2 - 2013-04-30 18:00 - Chris topher

- Status changed from New to Needs Feedback

- Target version deleted (6.1.1)

#3 - 2013-05-02 08:15 - Andreas Becker (Andi)

Hi Alexander

Thanks for this hint - previous Installations of TYPOS3 until 4.7 did not had this problem

Ad this hint to the install tool so people will know about it that TYPO3 since 6.1 is getting a "special case" like phpMyAdmin.

1. Remove skip-show-database if you use phpMyAdmin, TYPO3 or a similar tool to

2. manage your databases, it will just frustrate you or your users.

#skip-show-database

as i.e. virtualmin, adminer, chive shows you tables correctly even you are logged in as a user and "skip-show-database" enabled

i.e. if your logged in a typo3 installation and have adminer installed your database will show up correctly

or even better perform a check before installing TYPO3 6.1 of all Server requirements to run TYPO3 6.1+ and than continue with the installation. In

this case the hint should simply pop up when "skip-show-database" is not disabled

Andi

#4 - 2013-05-02 18:43 - Alexander Opitz

Also previous installations of TYPO3 have this problem.

Anyway, how does virtualmin, adminer, chive, ... can show the databases if "SHOW DATABASES" isn't allowed for the user?

BTW. a check for this (and other DB privileges are planed.

2015-08-04 2/5


https://review.typo3.org/23795

#5 - 2013-05-03 08:28 - Andreas Becker (Andi)

Hi Alexander you wrote:

"Anyway, how does virtualmin, adminer, chive, ... can show the databases if "SHOW DATABASES" isn't allowed for the user?"

| only wrote about what is what it is. only phpMyAdmin and TYPO3 seems to have problems with this settings.

Andi

#6 - 2013-05-03 14:07 - Alexander Opitz

As I've no crystal ball, | can't predict why it should work with "virtualmin, adminer, chive" on your system and not with TYPOS3 and phpMyAdmin.

Also, if this configuration would be the same as with TYPO3 4.7, you should had this problem already with 4.7, as the code didn't changed on this
point. So this all (and most of the other bugs from you) seem to be a problem of your system.

#7 - 2013-05-03 14:49 - Andreas Becker (Andi)

Well it is not one but 3 systems which are different from each other (and only one is ours) and same symptoms. Until 4.7 we had never those
problems! right! but also adminer integrated in the TYPO3 backend was just working fine and much better than phpmyadmin. On the servers itself has
nothing changed afaik.

Nevertheless | would put a hint into the install tool so people know that TYPOS3 is like phpmyadmin a special case which will not make them happy if

they have it enabled.

#8 - 2013-09-05 09:16 - Alexander Opitz
- Status changed from Needs Feedback to New

Add test for privileges "Show databases" to install tool.

#9 - 2013-09-05 12:28 - Ernesto Baschny

- Status changed from New to Accepted

- Complexity set to easy

| agree that we need a better handling for that. But | would not require SHOW DATABASES priviledge.

1) admin_get_dbs() should thow an Exception instead of Fatal error in this situation (when $db_list === FALSE)

2) Install tool should catch this exception and then instead of presenting a list of databases just an empty INPUT field where the user has to enter the
database name himself

| was about to create this patch for 6.2 but then | had to fiddle with the FLUID templates and got stuck.. but it should be easy for the FLUID wizards out
there.

For 6.0+6.1 | would simply catch the error in "Basic Configuration" and ignore it (as it is not relevant when you are there) and do something similar as
(2) for the first install (or skip this part, as it's probably not worth adding it to 6.0+1 anymore).

#10 - 2013-09-05 14:14 - Alexander Opitz

Since TYPO3 CMS 4.7 the minimum MySQL version is 5.0, since this version we could also use:

SELECT SCHEMA_NAME FROM information_schema.SCHEMATA

to get the databases to which we have access. Maybe changing the "SHOW DATABASE" to this could be enough.

#11 - 2013-09-05 14:28 - Alexander Opitz

Tested localy:

> SHOW DATABASES
#1227 - Access denied; you need (at least one of) the SHOW DATABASES privilege(s) for this operation

> SELECT SCHEMA_NAME FROM information_schema.SCHEMATA
SCHEMA_NAME

information_schema

So best way to go is to change the SQL statement.

The DBAL native driver uses the deprecated php funtion "mysq|_list_dbs" which will do a "SHOW DATABASES" this should be changed in another
issue report.

#12 - 2013-09-05 14:55 - Alexander Opitz

- Assigned To set to Alexander Opitz

#13 - 2013-09-05 15:04 - Gerrit Code Review

- Status changed from Accepted to Under Review

Patch set 1 for branch master has been pushed to the review server.
It is available at https://review.typo3.0rg/23637

#14 - 2013-09-05 15:06 - Alexander Opitz

To test the patch you need to change the my.cfg of your mysql server. You need to add "skip-show-database" to the [mysqld] section and restart your

mysql server.

#15 - 2013-09-05 17:31 - Gerrit Code Review

Patch set 2 for branch master has been pushed to the review server.
It is available at https://review.typo3.0rg/23637
#16 - 2013-09-05 17:32 - Ernesto Baschny

Oh dear, that makes this setting pretty useless as a "security mechanism" then. Thanks for researching.

#17 - 2013-09-05 18:44 - Alexander Opitz

Not really, "SHOW DATABASES" can show more databases then where you have no privileges, the shema only shows databases where you have

some. ;)

#18 - 2013-09-06 10:50 - Gerrit Code Review

Patch set 3 for branch master has been pushed to the review server.
It is available at https://review.typo3.org/23637

#19 - 2013-09-11 16:08 - Gerrit Code Review

Patch set 4 for branch master has been pushed to the review server.
It is available at https://review.typo3.0rg/23637

#20 - 2013-09-12 18:52 - Gerrit Code Review

Patch set 5 for branch master has been pushed to the review server.
It is available at https://review.typo3.0rg/23637

#21 - 2013-09-12 19:54 - Gerrit Code Review

Patch set 1 for branch TYPO3_6-1 has been pushed to the review server.
It is available at https://review.typo3.0rg/23795

#22 - 2013-09-12 20:30 - Alexander Opitz
- Status changed from Under Review to Resolved
- % Done changed from 0 to 100

Applied in changeset commit:71690327d2c7e07efae3637d6d1c26c071b385e8.
